package com.steerinfo.baseinfo.meterbasecalibrastandard.controller;

import com.steerinfo.baseinfo.meterbasecalibrastandard.model.MeterBaseCalibraStandard;
import com.steerinfo.baseinfo.meterbasecalibrastandard.service.IMeterBaseCalibraStandardService;
import com.steerinfo.baseinfo.meterbasecalibrationtime.model.MeterBaseCalibrationTime;
import com.steerinfo.baseinfo.meterbasespotinfo.model.MeterBaseSpotInfo;
import com.steerinfo.framework.controller.BaseRESTfulController;
import com.steerinfo.framework.controller.RESTfulResult;
import com.steerinfo.framework.service.pagehelper.PageList;
import com.steerinfo.framework.utils.collection.ListUtils;
import com.steerinfo.util.StringUtils;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.transaction.interceptor.TransactionAspectSupport;
import org.springframework.web.bind.annotation.*;

import java.util.Arrays;
import java.util.HashMap;
import java.util.List;

/**
 * MeterBaseCalibraStandard RESTful接口：
 * @author generator
 * @version 1.0-SNAPSHORT 2022-01-07 09:29
 * 类描述
 * 修订历史：
 * 日期：2022-01-07
 * 作者：generator
 * 参考：
 * 描述：MeterBaseCalibraStandard RESTful接口
 * @see null
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 */
@RestController
@RequestMapping("/${api.version}/meterbasecalibrastandards")
@Api(value = "/${api.version}/meterbasecalibrastandards", tags = "校秤标准管理 - MeterBaseCalibraStandardController")
public class MeterBaseCalibraStandardController extends BaseRESTfulController {

    @Autowired
    IMeterBaseCalibraStandardService meterBaseCalibraStandardService;

    @ApiOperation(value="获取列表", notes="分页查询")
    @ApiImplicitParams({
        @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
        @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterbasecalibrastandard:view")
    @GetMapping(value = "/")
    public RESTfulResult list(@RequestParam HashMap parmas,Integer pageNum, Integer pageSize){
        PageList<MeterBaseCalibraStandard> list = meterBaseCalibraStandardService.queryForPage(parmas, pageNum, pageSize);
        return success(list);
    }

    @ApiOperation(value="获取列表", notes="分页模糊查询")
    @ApiImplicitParams({
        @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
        @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterbasecalibrastandard:view")
    @GetMapping(value = "/like/")
    public RESTfulResult listLike(@RequestParam HashMap parmas,Integer pageNum, Integer pageSize){
        PageList<MeterBaseCalibraStandard> list = meterBaseCalibraStandardService.queryLikeForPage(parmas, pageNum, pageSize);
        return success(list);
    }
    
    @ApiOperation(value="创建", notes="根据MeterBaseCalibraStandard对象创建")
    @ApiImplicitParam(name = "meterBaseCalibraStandard", value = "详细实体meterBaseCalibraStandard", required = true, dataType = "MeterBaseCalibraStandard")
    //@RequiresPermissions("meterbasecalibrastandard:create")
    @PostMapping(value = "/")
    public RESTfulResult add(@RequestBody MeterBaseCalibraStandard model){
        //system.out.println("grjtymkyk,uil"+model);
        MeterBaseCalibraStandard meterBaseCalibraStandard = meterBaseCalibraStandardService.add(model);

        return success(meterBaseCalibraStandard);
    }

    @ApiOperation(value="创建", notes="根据MeterBaseCalibraStandard对象创建")
    @ApiImplicitParam(name = "meterBaseCalibraStandard", value = "详细实体meterBaseCalibraStandard", required = true, dataType = "MeterBaseCalibraStandard")
    //@RequiresPermissions("meterbasecalibrastandard:create")
    @Transactional
    @PostMapping(value = "/insert")
    public RESTfulResult addInsert(@RequestBody MeterBaseCalibraStandard model){
//        //system.out.println("grjtymkyk,uil"+model);
//        MeterBaseCalibraStandard meterBaseCalibraStandard = meterBaseCalibraStandardService.checkandadd(model);
//
//        return success(meterBaseCalibraStandard);
        try {
            String msg = meterBaseCalibraStandardService.checkandadd(model);
            if (msg != null && !msg.equals("")) {
                return failed(null, msg);
            }
        } catch (Exception e) {
            e.printStackTrace();
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            return failed(null, "操作异常，请确认！");
        }
        return success();
    }

    @ApiOperation(value = "更新详细信息", notes = "根据url的id来指定更新对象，并根据传过来的MeterBaseCalibraStandard信息来更新详细信息")
    @ApiImplicitParams({
            @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String"),
            @ApiImplicitParam(name = "meterBaseCalibraStandard", value = "详细实体meterBaseCalibraStandard", required = true, dataType = "MeterBaseCalibraStandard")
    })
    //@RequiresPermissions("meterbasecalibrationtime:update")
    @Transactional
    @PutMapping(value = "/update/{id}", produces = "application/json;charset=UTF-8")
    public RESTfulResult updateBody(@PathVariable String id,@RequestBody MeterBaseCalibraStandard model) {
        try {
            String msg = meterBaseCalibraStandardService.checkandupdate(id,model);
            if (msg != null && !msg.equals("")) {
                return failed(null, msg);
            }
        } catch (Exception e) {
            e.printStackTrace();
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            return failed(null, "操作异常，请确认！");
        }

        return success();
    }

    @ApiOperation(value = "启用标识符", notes = "根据传过来的MeterBaseCalibraStandard集合信息来更新详细信息")
    @Transactional
    @PostMapping(value = "/Recovery")
    public RESTfulResult recovery(@RequestBody List<MeterBaseCalibraStandard> models) {
        try {
            String msg = meterBaseCalibraStandardService.recovery(models);
            if (StringUtils.isNotEmpty(msg)) {
                return failed(null, msg);
            }
        } catch (Exception e) {
            e.printStackTrace();
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            return failed(null, "操作异常，请确认！");
        }
        return success();
    }

    @ApiOperation(value = "废除标识符", notes = "根据传过来的MeterBaseCalibraStandard集合信息来更新详细信息")
    @ApiImplicitParams({

            @ApiImplicitParam(name = "MeterBaseCalibraStandard", value = "详细实体MeterBaseCalibraStandard", required = true, dataType = "MeterBaseSpotInfo")
    })
    //@RequiresPermissions("combaseinfo:update")
    @Transactional
    @PostMapping(value = "/abolish")
    public RESTfulResult abolish(@RequestBody List<MeterBaseCalibraStandard> models) {
        try {
            String msg = meterBaseCalibraStandardService.abolish(models);
            if (StringUtils.isNotEmpty(msg)) {
                return failed(null, msg);
            }
        } catch (Exception e) {
            e.printStackTrace();
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            return failed(null, "操作异常，请确认！");
        }
        return success();
    }

    @ApiOperation(value="获取详细信息", notes="根据url的id来获取详细信息")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("meterbasecalibrastandard:view")
    @GetMapping(value = "/{id}")
    public RESTfulResult get(@PathVariable String id){
        MeterBaseCalibraStandard meterBaseCalibraStandard = meterBaseCalibraStandardService.getById(id);
        return success(meterBaseCalibraStandard);
    }

    @ApiOperation(value="更新详细信息", notes="根据url的id来指定更新对象，并根据传过来的meterBaseCalibraStandard信息来更新详细信息")
    @ApiImplicitParams({
        @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String"),
        @ApiImplicitParam(name = "meterBaseCalibraStandard", value = "详细实体meterBaseCalibraStandard", required = true, dataType = "MeterBaseCalibraStandard")
    })
    //@RequiresPermissions("meterbasecalibrastandard:update")
    @PutMapping(value = "/{id}", produces  = "application/json;charset=UTF-8")
    public RESTfulResult update(@PathVariable String id, @RequestBody MeterBaseCalibraStandard model){
        model.setId(id);
        MeterBaseCalibraStandard meterBaseCalibraStandard = meterBaseCalibraStandardService.modify(model);
        return success(meterBaseCalibraStandard);
    }

    @ApiOperation(value="删除", notes="根据url的id来指定删除对象")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("meterbasecalibrastandard:delete")
    @DeleteMapping(value = "/{id}")//String
    public RESTfulResult delete(@PathVariable String id){
    	List<String> list = Arrays.asList(id.split(","));
    	if(ListUtils.isNotEmpty(list)) {
	    	List<String> ids = ListUtils.convertList(list);
			  meterBaseCalibraStandardService.delete(ids);
    	}
      return success();
    }
    @GetMapping("/findall")
    public List<MeterBaseCalibraStandard> findAll(){
        List<MeterBaseCalibraStandard> list=meterBaseCalibraStandardService.findAll();
        return list;
    }
}
